/*
 * uData API
 * uData API
 *
 * OpenAPI spec version: 1.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.asso.ladoxa.datagouv.models;

import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModelProperty;

import java.util.Objects;

/**
 * Task
 */

public class Task {
  @JsonProperty("exc")
  private String exc = null;

  @JsonProperty("id")
  private String id = null;

  @JsonProperty("result")
  private String result = null;

  /**
   * Cron expression for hour
   */
  public enum StatusEnum {
    RECEIVED("RECEIVED"),
    
    RETRY("RETRY"),
    
    SUCCESS("SUCCESS"),
    
    STARTED("STARTED"),
    
    PENDING("PENDING"),
    
    FAILURE("FAILURE"),
    
    REVOKED("REVOKED");

    private String value;

    StatusEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static StatusEnum fromValue(String text) {
      for (StatusEnum b : StatusEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("status")
  private StatusEnum status = null;

  @JsonProperty("traceback")
  private String traceback = null;

  public Task exc(String exc) {
    this.exc = exc;
    return this;
  }

   /**
   * The exception thrown during execution
   * @return exc
  **/
  @ApiModelProperty(value = "The exception thrown during execution")
  public String getExc() {
    return exc;
  }

  public void setExc(String exc) {
    this.exc = exc;
  }

   /**
   * Tha task execution ID
   * @return id
  **/
  @ApiModelProperty(value = "Tha task execution ID")
  public String getId() {
    return id;
  }

  public Task result(String result) {
    this.result = result;
    return this;
  }

   /**
   * The task results if exists
   * @return result
  **/
  @ApiModelProperty(value = "The task results if exists")
  public String getResult() {
    return result;
  }

  public void setResult(String result) {
    this.result = result;
  }

   /**
   * Cron expression for hour
   * @return status
  **/
  @ApiModelProperty(example = "RECEIVED", value = "Cron expression for hour")
  public StatusEnum getStatus() {
    return status;
  }

  public Task traceback(String traceback) {
    this.traceback = traceback;
    return this;
  }

   /**
   * The execution traceback
   * @return traceback
  **/
  @ApiModelProperty(value = "The execution traceback")
  public String getTraceback() {
    return traceback;
  }

  public void setTraceback(String traceback) {
    this.traceback = traceback;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Task task = (Task) o;
    return Objects.equals(this.exc, task.exc) &&
        Objects.equals(this.id, task.id) &&
        Objects.equals(this.result, task.result) &&
        Objects.equals(this.status, task.status) &&
        Objects.equals(this.traceback, task.traceback);
  }

  @Override
  public int hashCode() {
    return Objects.hash(exc, id, result, status, traceback);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Task {\n");

    sb.append("    exc: ").append(toIndentedString(exc)).append("\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    result: ").append(toIndentedString(result)).append("\n");
    sb.append("    status: ").append(toIndentedString(status)).append("\n");
    sb.append("    traceback: ").append(toIndentedString(traceback)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

